// FileQueryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OCXPlayDemo.h"
#include "FileQueryDlg.h"
#include "CommonDef.h"
#include "SwallowFunction.h"
#include "CommonDefine.h"


// CFileQueryDlg dialog

#define MAX_VALUME_NUM		65535		//ֵ
#define MAX_SEEK_NUM 99
#define MIN_SEEK_NUM 0

IMPLEMENT_DYNAMIC(CFileQueryDlg, CDialog)

CFileQueryDlg::CFileQueryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileQueryDlg::IDD, pParent)
{
	for (int i = 0; i < 10; i++)
	{
		m_strDownLoadPos.uiDownloadID[i] = -1;
	}
	m_bPlaying = false;
	m_blTempLocalPlayAdjust = false;
    m_iLogonID = -1;
	m_iLocalPlayFastValue = 0;
	m_iLocalPlaySlowValue = 0;
	m_iLocalPlayStatus = -1;
	m_iLocalPlayStepForward = FALSE;
	m_blBegainClip = FALSE;
	m_pSwallowPlayback = NULL;

	TCHAR	caInstDir[MAX_PATH]	=	{0};

	//Get the installed directory
	DWORD	dwBufLen=MAX_PATH;
	LONG	lRet	=	0;
	HKEY	hKey	=	NULL;
#ifdef SWALLOW_V6
	lRet	=	RegOpenKeyEx( HKEY_CLASSES_ROOT,
		TEXT("CLSID\\{24794EE9-53D5-4E65-B96D-D88567D3089C}\\InprocServer32"),
		0, KEY_QUERY_VALUE, &hKey );
#elif defined SWALLOW_64
	lRet	=	RegOpenKeyEx( HKEY_CLASSES_ROOT,
		TEXT("CLSID\\{ABB8C824-FC86-4EB3-8FB1-11623B50BDAE}\\InprocServer32"),
		0, KEY_QUERY_VALUE, &hKey );
#else
	lRet	=	RegOpenKeyEx( HKEY_CLASSES_ROOT,
		TEXT("CLSID\\{F4986929-536B-40A8-9398-7CEE72DBA480}\\InprocServer32"),
		0, KEY_QUERY_VALUE, &hKey );
#endif
	if( lRet != ERROR_SUCCESS )
	{
		OutputDebugString("ûаװactiveؼ");
		return;
	}

	lRet	=	RegQueryValueEx( hKey, NULL,	NULL, NULL, (LPBYTE)caInstDir, &dwBufLen);
	RegCloseKey( hKey );

	if( (lRet != ERROR_SUCCESS)	||	(dwBufLen > MAX_PATH) )
	{
		OutputDebugString("ûаװactiveؼ");
		return;
	}

	CString szTemp	=	caInstDir;
	_tcscpy_s(caInstDir,	MAX_PATH*sizeof(TCHAR),	szTemp.Left(szTemp.ReverseFind('\\')+1));
	CString	strIni	=	caInstDir;
	strIni			+=	"NVSIEConfig.ini";

	char cPathTemp[MAX_PATH] = {0};
	GetPrivateProfileString ("PATH", "SAVEPATH", NULL, cPathTemp, sizeof(cPathTemp), strIni);
	m_cstrSavePath = cPathTemp;

	//if ('\\'	!=	m_cstrSavePath.GetAt(m_cstrSavePath.GetLength()-1))
	//	m_cstrSavePath	+=	'\\';
    

}

CFileQueryDlg::~CFileQueryDlg()
{
	if (NULL != m_pSwallowPlayback)
	{
		delete m_pSwallowPlayback;
		m_pSwallowPlayback = NULL;
	}
}

void CFileQueryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_FILE, m_FileList);
	DDX_Control(pDX, IDC_DATETIMEPICKER_START, DataTime_Start);
	DDX_Control(pDX, IDC_DATETIMEPICKER3, DataTime_End);
	DDX_Control(pDX, IDC_DATETIMEPICKER_StartTime, DataTime_StartTime);
	DDX_Control(pDX, IDC_DATETIMEPICKER_EndTime, DataTime_EndTime);
	DDX_Control(pDX, IDC_PROGRESS_PLAY, m_PlayProgress);
	//DDX_Control(pDX, IDC_SWALLOWCTRL1, m_pSwallowPlayback);
	DDX_Control(pDX, IDC_CBO_STREAM, m_CboStream);
	DDX_Control(pDX, IDC_COMBO_Channel, m_CboChannelNo);
}


BEGIN_MESSAGE_MAP(CFileQueryDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DOWNLOAD, &CFileQueryDlg::OnBnClickedButtonDownload)
	ON_BN_CLICKED(IDC_BUTTON_PLAYBYFILE, &CFileQueryDlg::OnBnClickedButtonPlaybyfile)
	ON_BN_CLICKED(IDC_BUTTON_FIRSTPAGE, &CFileQueryDlg::OnBnClickedButtonFirstpage)
	ON_BN_CLICKED(IDC_BUTTON_PREPAGE, &CFileQueryDlg::OnBnClickedButtonPrepage)
	ON_BN_CLICKED(IDC_BUTTON_NEXTPAGE, &CFileQueryDlg::OnBnClickedButtonNextpage)
	ON_BN_CLICKED(IDC_BUTTON_LASTPAGE, &CFileQueryDlg::OnBnClickedButtonLastpage)
	ON_BN_CLICKED(IDC_BUTTON_STOPDOWNLOAD, &CFileQueryDlg::OnBnClickedButtonStopdownload)
	ON_BN_CLICKED(IDC_BUTTON_STOPPLAYBYFILE, &CFileQueryDlg::OnBnClickedButtonStopplaybyfile)
	ON_BN_CLICKED(IDC_BUTTON_QUERY, &CFileQueryDlg::OnBnClickedButtonQuery)
	ON_WM_TIMER()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_FILE, &CFileQueryDlg::OnLvnItemchangedListFile)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_PLAYLOCAL, &CFileQueryDlg::OnBnClickedButtonPlaylocal)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_PROGRESS, &CFileQueryDlg::OnNMCustomdrawSliderProgress)
	ON_BN_CLICKED(IDC_BUTTON_DEC, &CFileQueryDlg::OnBnClickedButtonDec)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_SLOWVIDEO, &CFileQueryDlg::OnBnClickedBtnLocalplaySlowvideo)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_FASTVIDEO, &CFileQueryDlg::OnBnClickedBtnLocalplayFastvideo)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_PLAY_PAUSE, &CFileQueryDlg::OnBnClickedBtnLocalplayPlayPause)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_STEPVIDEO, &CFileQueryDlg::OnBnClickedBtnLocalplayStepvideo)
	ON_BN_CLICKED(IDC_BTN_STOP_LOCALPLAY, &CFileQueryDlg::OnBnClickedBtnStopLocalplay)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_CAPTURE_PIC, &CFileQueryDlg::OnBnClickedBtnLocalplayCapturePic)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_CAPTURE_FILE, &CFileQueryDlg::OnBnClickedBtnLocalplayCaptureFile)
	ON_BN_CLICKED(IDC_CHK_VOLUEM_START, &CFileQueryDlg::OnBnClickedChkVoluemStart)
	ON_BN_CLICKED(IDC_BTN_PBK_BY_TIME, &CFileQueryDlg::OnBnClickedBtnPbkByTime)
	ON_BN_CLICKED(IDC_BTN_LOCALPLAY_SEEK, &CFileQueryDlg::OnBnClickedBtnLocalplaySeek)
END_MESSAGE_MAP()


void CFileQueryDlg::OnBnClickedButtonDownload()
{
	m_iDownloadCount = 0;
	POSITION pos = m_FileList.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		TRACE(_T("No items were selected!\n"));
		return;
	}

	int nItem = m_FileList.GetNextSelectedItem(pos);
	m_strDownLoadPos.cRemoteFileName = m_FileList.GetItemText(nItem, 0);
	CString szDownLoadFileName;
	//szDownLoadFileName.Format("%s\\%s", m_cstrSavePath,m_strDownLoadPos.cRemoteFileName);
	szDownLoadFileName.Format("%s",m_strDownLoadPos.cRemoteFileName);
	int iFalg = 0;

	int iDLId = Swallow_StartDownload(m_pSwallowPlayback, m_iLogonID, m_strDownLoadPos.cRemoteFileName, szDownLoadFileName, iFalg);

	if (iDLId < 0)
	{
		return;
	}
	m_strDownLoadPos.uiDownloadID[m_iDownloadCount] = iDLId;
	EnableSomeControl(FALSE);
	m_iItemOfDownload[m_iDownloadCount] = nItem;
	m_iDownloadCount++;
}

void CFileQueryDlg::OnBnClickedButtonPlaybyfile()
{
	if (m_bPlaying)
	{
		return;
	}
	if (0 == Play(m_pSwallowPlayback->GetCurObs(), m_iLogonID, 1, m_strDownLoadPos.cRemoteFileName, 0))
	{
		m_bPlaying = true;
		SetTimer(1, 500, NULL);
	}
}

void CFileQueryDlg::OnBnClickedButtonFirstpage()
{
	m_iCurrentPage = 1;
	QueryRecordFile(m_iCurrentPage - 1);
}

void CFileQueryDlg::OnBnClickedButtonPrepage()
{
	if (m_iCurrentPage > 1)
	{
		m_iCurrentPage--;
	}
	QueryRecordFile(m_iCurrentPage - 1);
}

void CFileQueryDlg::OnBnClickedButtonNextpage()
{
	if (m_iCurrentPage < m_iTotalPage)
	{
		m_iCurrentPage++;
	}
	QueryRecordFile(m_iCurrentPage - 1);
}

void CFileQueryDlg::OnBnClickedButtonLastpage()
{
	m_iCurrentPage = m_iTotalPage;
	QueryRecordFile(m_iCurrentPage - 1);
}

void CFileQueryDlg::OnBnClickedButtonStopdownload()
{
	if (-1 == m_strDownLoadPos.uiDownloadID[0])
	{
		return;
	}

	int iRet = Swallow_StopDownload(m_pSwallowPlayback, m_strDownLoadPos.uiDownloadID[0]);
	if (0 == iRet)
	{		
		m_FileList.SetItemText(m_iItemOfDownload[0], 5, "");
	}
	m_strDownLoadPos.uiDownloadID[0] = -1;

	KillTimer(0);
	m_iDownloadCount = 0;
	EnableSomeControl(TRUE);
}

void CFileQueryDlg::OnBnClickedButtonStopplaybyfile()
{
	if (m_bPlaying)
	{		
		long lobsID  = m_pSwallowPlayback->GetCurObs();
		VARIANT var  = getitovar(0);
		VARIANT var1 = getitovar(lobsID);
		CString szRet = m_pSwallowPlayback->Commander(Obs_Stop_Cmd, var1, var, var, var, var, var, var, var, var);    
		CStringArray szResult;
		szResult.SetSize(256);
		//if (CheckRetValue(szRet, szResult) == 0)//todotodo
		{
			OutputDebugString("success\n");
			m_bPlaying = false;
			Invalidate();
			KillTimer(1);
			m_PlayProgress.SetPos(0);
		}
	}
}

void CFileQueryDlg::OnBnClickedButtonQuery()
{
	m_iCurrentPage = 1;
	QueryRecordFile(m_iCurrentPage - 1);
}

int CFileQueryDlg::GetPlayBackProgress(int _iObsId)
{
	int iCurPlayPos = 0;
	iCurPlayPos = Swallow_GetProgress(m_pSwallowPlayback, _iObsId);
	if (iCurPlayPos < 0 || iCurPlayPos > 100)
	{
		return -1;
	}
	return iCurPlayPos;
}

int CFileQueryDlg::Play(long _lobsId, long _lLongonId, long _lFileSrc, CString _szFileName, long _lIndex)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getitovar(_lLongonId);
	VARIANT var3 = getitovar(_lFileSrc);
	VARIANT var4 = getstovar(_szFileName);
	VARIANT var5 = getitovar(_lIndex);
	CString szRet = m_pSwallowPlayback->Commander(Obs_StartPlayBack_Cmd, var1, var2, var3, var4, var5, var, var, var, var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		return 0;
	}
	return -1;
}

int CFileQueryDlg::PlayLocalFile(long _lobsId, CString _szFileName)
{
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(_lobsId);
	VARIANT var2 = getstovar(_szFileName);
	CString szRet = m_pSwallowPlayback->Commander(Obs_StartPlayBackOffLine_Cmd, var1, var2, var, var, var, var, var, var, var);
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, "Pause");
	m_iLocalPlayStatus = 0;
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		//szRet = m_pSwallowPlayback->Commander(Obs_MarkIfo_Get, var1, var, var, var, var, var, var, var, var);
		return 0;
	}

	return -1;
}

void CFileQueryDlg::EnableSomeControl(BOOL _blEnable)
{
	GetDlgItem(IDC_BUTTON_FIRSTPAGE)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_LASTPAGE)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_PREPAGE)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_NEXTPAGE)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_QUERY)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_DOWNLOAD)->EnableWindow(_blEnable);
	GetDlgItem(IDC_BUTTON_PLAYBYFILE)->EnableWindow(_blEnable);
}

void CFileQueryDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (0 == nIDEvent)     //ʱ״̬
	{	
		int iDlId = m_strDownLoadPos.uiDownloadID[0];
		if (-1 == iDlId)
		{
			return;
		}
		
		int iPos = 0;
		int iSize = 0;
		int iRet = Swallow_GetDownloadPos(m_pSwallowPlayback, iDlId, m_strDownLoadPos.iPos, m_strDownLoadPos.iDownLoadSize);
		if (0 != iRet)
		{
			return;
		}

		CString strPos;
		strPos.Format("%d%", m_strDownLoadPos.iPos);
		m_FileList.SetItemText(m_iItemOfDownload[0], 1,  strPos);

		if (m_iDownloadCount <= 0)
		{
			EnableSomeControl(TRUE);
			KillTimer(0);
		}
	}
	else if (1 == nIDEvent)   //ʱⲥ״̬ ˢ²ʱ
	{
		if(m_bPlaying)
		{
			CSliderCtrl *sldProgress = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS);
			sldProgress->SetPos(GetPlayBackProgress(m_pSwallowPlayback->GetCurObs()));		
			if (m_cstrPlayRemoteBegainTime.IsEmpty())
			{
				UpdatePlayingTimeByFile();
			}
			else
			{
				UpdatePlayingTimeByTime();
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}

BOOL CFileQueryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//
	RECT rcShow = {0};
	GetDlgItem(IDC_GBO_SWALLOW_PLAYBACK)->GetWindowRect(&rcShow);
	ScreenToClient(&rcShow);
	m_pSwallowPlayback = new CSwallow();
	int iRet = m_pSwallowPlayback->Create(_T(""),_T(""), WS_CHILDWINDOW, rcShow, this, IDC_SWALLOWCTRL1);
	m_pSwallowPlayback->ShowWindow(SW_SHOW);
	m_pSwallowPlayback->MoveWindow(&rcShow);
	
	CTime destTime = CTime::GetCurrentTime() - CTimeSpan( 30, 0, 0, 0 );


	DataTime_Start.SetTime(&destTime);


	CSliderCtrl *sldBrightness = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS);
	((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->SetRange(0,100);	//
	sldBrightness->SetRange(0,100);
	sldBrightness = NULL;

	/*VARIANT var = getitovar(0);
	m_pSwallowPlayback->Commander(Obs_Add_Cmd,var,var,var,var,var,var,var,var,var);
	m_pSwallowPlayback->SetiInitializtion(0);
	m_pSwallowPlayback->SetiLanguage(0);
	long result=m_pSwallowPlayback->GetCurObs();*/

	//ʼSwallow
	Swallow_Init(m_pSwallowPlayback, 1, 1, 1, 1);	
	//ôڸ
	Swallow_SetWindowMode(m_pSwallowPlayback, 1);

	//ļбʼ
	m_lvItem.mask = LVCF_TEXT | LVCF_FMT | LVCF_WIDTH;
	m_lvItem.fmt = LVCFMT_LEFT;
	m_lvItem.pszText = ("File Name");
	m_lvItem.cx = 180;
	m_FileList.InsertColumn(0, &m_lvItem);
	//m_lvItem.pszText = ("Type");
	//m_lvItem.cx = 40;
	//m_FileList.InsertColumn(1, &m_lvItem);
	//m_lvItem.pszText = ("Channel");
	//m_lvItem.cx = 55;
	//m_FileList.InsertColumn(2, &m_lvItem);
	//m_lvItem.pszText = ("Size(Bytes)");
	//m_lvItem.cx = 75;
	//m_FileList.InsertColumn(3, &m_lvItem);
	//m_lvItem.pszText = ("Time");
	//m_lvItem.cx = 110;
	//m_FileList.InsertColumn(4, &m_lvItem);
	m_lvItem.pszText = ("Download");
	m_lvItem.cx = 70;
	m_FileList.InsertColumn(1, &m_lvItem);
	DWORD style = LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	m_FileList.SetExtendedStyle(style);

	//ͨļ͡¼
	//m_iChannelNum = -1;
	//NetClient_GetChannelNum(m_iLogonID, &m_iChannelNum);
	m_CboChannelNo.SetItemData(m_CboChannelNo.AddString(_T("ALL")), 0);
	for (int i = 1; i <= m_iTotalChannel; i++)
	{
		char ch[16];
		sprintf_s(ch, 8, "CH%d",i);
		m_CboChannelNo.SetItemData(m_CboChannelNo.AddString(CA2CT(ch)), i);
	}

	SetDlgItemText(IDC_STATIC_OSD, m_cstrNvsIP);

	//m_iItemOfList = 0;
	((CComboBox*)GetDlgItem(IDC_COMBO_Channel))->SetCurSel(1);
	((CComboBox*)GetDlgItem(IDC_COMBO_FILETYPE))->SetCurSel(1);
	((CComboBox*)GetDlgItem(IDC_COMBO_RECORDTYPE))->SetCurSel(0);

	StopPlayInitVulue();

	InitStreamCbo();

	return TRUE;
}


BEGIN_EVENTSINK_MAP(CFileQueryDlg, CDialog)
	ON_EVENT(CFileQueryDlg, IDC_SWALLOWCTRL1, 7, CFileQueryDlg::QueryResultSwallowctrl1, VTS_I4 VTS_BSTR)
	ON_EVENT(CFileQueryDlg, IDC_SWALLOWCTRL1, 9, CFileQueryDlg::OnDownLoadSwallowctrl1, VTS_UI4 VTS_UI4)
	ON_EVENT(CFileQueryDlg, IDC_SWALLOWCTRL1, 14, CFileQueryDlg::OnPlayBackSwallowctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CFileQueryDlg, IDC_SWALLOWCTRL1, 27, CFileQueryDlg::OnPlayBackDecryptSwallowctrl1, VTS_UI4 VTS_UI4)
	ON_EVENT(CFileQueryDlg, IDC_SWALLOWCTRL1, 38, CFileQueryDlg::OnRemoteDecryptSwallowctrl1, VTS_UI4 VTS_UI4)
END_EVENTSINK_MAP()

void CFileQueryDlg::QueryResultSwallowctrl1(long _lLogonID, LPCTSTR _bstrResult)
{
	CString szMsg = _bstrResult;
	int iSize = 0;
	CStringArray szResult;
	szResult.SetSize(256);
	SplitStringToArray(szMsg, "\b", szResult);
	CStringArray szInfo;
	szInfo.SetSize(256);
	SplitStringToArray(szResult[0], "\n", szInfo);
	iSize = _ttoi(szInfo[1]);
	OutputDebugString(szMsg);
	CStringArray szFileInfo;
	szFileInfo.SetSize(256);
	SplitStringToArray(szResult[1], "\n", szFileInfo);
	CString szMsg1 = szResult[1];
	m_iTotalFile = _ttoi(szFileInfo[0]);
	m_iTotalPage = ((m_iTotalFile%10 == 0)?m_iTotalFile/10:m_iTotalFile/10+1);
	/*for (int i = 0; i < iSize; i++)
	{
		m_FileList.InsertItem(0, szFileInfo[i + 1]);
	}*/
	m_FileList.DeleteAllItems();
	for (int i = iSize - 1; i >= 0; i--)
	{
		m_FileList.InsertItem(0, szFileInfo[i + 1]);
	}

	CString szPageInfo;
	szPageInfo.Format("%d", m_iTotalFile);
	GetDlgItem(IDC_STATIC_TOTALNUM)->SetWindowText(szPageInfo);
	szPageInfo.Format("%d", m_iTotalPage);
	GetDlgItem(IDC_STATIC_PAGENUM)->SetWindowText(szPageInfo);
	int iPage = (m_iTotalPage == 0) ? 0: m_iCurrentPage;
	szPageInfo.Format("%d", iPage);
	GetDlgItem(IDC_STATIC_CURRENTPAGENUM)->SetWindowText(szPageInfo);
}

void CFileQueryDlg::OnLvnItemchangedListFile(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	//szDownLoadFile = m_FileList.GetItemText(pNMLV->iItem, 0);//ȡ굥ļ
	m_strDownLoadPos.cRemoteFileName = m_FileList.GetItemText(pNMLV->iItem, 0);//ȡ굥ļ
	*pResult = 0;
}

void CFileQueryDlg::QueryRecordFile(int _iPageNo)
{
	int iChannel = ((CComboBox*)GetDlgItem(IDC_COMBO_Channel))->GetCurSel();
	if (iChannel == 0)
	{
		iChannel = 0xFF;
	}
	else
	{
		iChannel = iChannel - 1;
	}

	int iFiletype = ((CComboBox*)GetDlgItem(IDC_COMBO_FILETYPE))->GetCurSel();
	int iRecordType = ((CComboBox*)GetDlgItem(IDC_COMBO_RECORDTYPE))->GetCurSel();
	if (iRecordType == 0)
	{
		iRecordType = 0xFF;
	}

	CTime pStartDay;
	DataTime_Start.GetTime(pStartDay);
	int iYear = pStartDay.GetYear();
	int iMonth = pStartDay.GetMonth();
	int iDay = pStartDay.GetDay();

	CTime pStartTime;
	DataTime_StartTime.GetTime(pStartTime);
	int iHour = pStartTime.GetHour();
	int iMinute = pStartTime.GetMinute();
	int iSecond = pStartTime.GetSecond();
	CString szStartTime;
	szStartTime.Format("%04d%02d%02d%02d%02d%02d", iYear, iMonth, iDay, iHour, iMinute, iSecond);

	CTime pEndDay;
	DataTime_End.GetTime(pEndDay);
	int iStopYear = pEndDay.GetYear();
	int iStopMonth = pEndDay.GetMonth();
	int iStopDay = pEndDay.GetDay();

	CTime pEndTime;
	DataTime_EndTime.GetTime(pEndTime);
	int iStopHour = pEndTime.GetHour();
	int iStopMinute = pEndTime.GetMinute();
	int iStopSecond = pEndTime.GetSecond();
	CString szStopTime;
	szStopTime.Format("%04d%02d%02d%02d%02d%02d", iStopYear, iStopMonth, iStopDay, iStopHour, iStopMinute, iStopSecond);

	VARIANT var1 = getitovar(m_iLogonID);
	VARIANT var2 = getitovar(iChannel);
	VARIANT var3 = getitovar(1);
	VARIANT var4 = getitovar(iFiletype);
	VARIANT var5 = getitovar(iRecordType);
	VARIANT var6 = getstovar(szStartTime);
	VARIANT var7 = getstovar(szStopTime);

	VARIANT var8 = getitovar(10);
	VARIANT var9 = getitovar(_iPageNo);

	CString szRet = m_pSwallowPlayback->Commander(Query_Query_Cmd, var1, var2, var3, var4, var5, var6, var7, var8, var9);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) == 0)
	{
		OutputDebugString("Query_Query_Cmd succeed");
	}
}
void CFileQueryDlg::OnDownLoadSwallowctrl1(unsigned long _ulDLID, unsigned long _ulMsg)
{
	//NetClient_NetFileStopDownloadFile(_uiID);		
	//if(m_ulID == _ulDLID)
	//{
	//	m_ulID = 0;
	//	m_iDownloading = 0;
	//	KillTimer(3);
	//}
    //todotodo
	for (int i = 0; i < 5; i++)
	{
		if (_ulDLID == m_strDownLoadPos.uiDownloadID[i])
		{
			if (_ulMsg == 0)
			{
				m_strDownLoadPos.uiDownloadID[i] = -1;
				m_iDownloadCount--;
				m_FileList.SetItemText(m_iItemOfDownload[i], 1, "Finished");
			}
			else
			{
				OutputDebugString("1213214\n");
			}
			if (m_iDownloadCount <= 0)
			{
				EnableSomeControl(TRUE);
			}	
		}
	}
}

void CFileQueryDlg::OnClose()
{
	if (m_bPlaying)
	{		
		VARIANT var  = getitovar(0);
		VARIANT var1 = getitovar(m_pSwallowPlayback->GetCurObs());
		CString szRet = m_pSwallowPlayback->Commander(Obs_Stop_Cmd, var1, var, var, var, var, var, var, var, var);    
		CStringArray szResult;
		szResult.SetSize(256);
		if (CheckRetValue(szRet, szResult) == 0)
		{
			OutputDebugString("success\n");
			m_bPlaying = false;
			Invalidate();
			KillTimer(1);
			m_PlayProgress.SetPos(0);
		}
	}

	for (int i = 0; i < 5; i++)
	{
		if (m_strDownLoadPos.uiDownloadID[i] != -1)
		{
			VARIANT var = getitovar(0);
			VARIANT var1 = getitovar(m_strDownLoadPos.uiDownloadID[i]);
			CString szRet = m_pSwallowPlayback->Commander(Store_DLStop_Cmd, var1, var, var, var, var, var, var, var, var);
			CStringArray szResult;
			szResult.SetSize(256);
			if (CheckRetValue(szRet, szResult) != 0)
			{
				OutputDebugString("stop error");
			}
		}	
	}
    KillTimer(0);
    m_bPlaying = false;
	UpdateData(FALSE);
	DestroyWindow();
	CDialog::OnClose();
}

void CFileQueryDlg::OnBnClickedButtonPlaylocal()
{
	CFileDialog dlgFile(TRUE, NULL, NULL, 4|2, _T("sdv|*.sdv|MP4|*.mp4|aac|*.aac|avi|*.avi||"));
	if (IDOK != dlgFile.DoModal())
	{
		return;
	}
	CString szPathName = dlgFile. GetPathName();
	if (0 == PlayLocalFile(m_pSwallowPlayback->GetCurObs(), szPathName))
	{
		m_bPlaying = true;
		SetTimer(1, 500, NULL);
	}
	else
	{
		int i = GetLastError();
		AfxMessageBox("play failed");
	}

}

void CFileQueryDlg::OnNMCustomdrawSliderProgress(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	
	CSliderCtrl *sldProgress = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS);
	int iProgress = sldProgress->GetPos();
    //todotodo
	*pResult = 0;
}

void CFileQueryDlg::OnPlayBackSwallowctrl1(long _ObsID, long _Event)
{

	CSliderCtrl *sldProgress = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS);
	sldProgress->SetPos(0);
	int iRet = Swallow_Stop(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnStopLocalplay] Stop play Failed!");
		return;
	}
	if (m_bPlaying)
	{
		AfxMessageBox("play end");
	}
	StopPlayInitVulue();
}

void CFileQueryDlg::OnBnClickedButtonDec()
{
	CString szKey;
	GetDlgItem(IDC_EDIT_DEC)->GetWindowText(szKey);
	VARIANT var = getitovar(0);
	VARIANT var1 = getitovar(m_pSwallowPlayback->GetCurObs());
	VARIANT var2 = getstovar(szKey);
	VARIANT var3 = getitovar(szKey.GetLength());
	CString szRet = m_pSwallowPlayback->Commander(DEVICE_DECRYPTREC_SET,var1,var2,var3,var,var,var,var,var,var);
	CStringArray szResult;
	szResult.SetSize(256);
	if (CheckRetValue(szRet, szResult) != 0)
	{
		AfxMessageBox("decrypt record failed");
	}
	
}

void CFileQueryDlg::OnPlayBackDecryptSwallowctrl1(unsigned long _lobsId, unsigned long _lNotifyType)
{
	if (m_pSwallowPlayback->GetCurObs() != _lobsId)
	{
		return;
	}
	switch (_lNotifyType)
	{
	case LMSG_PLAYBACK_NEED_DECRYPT_KEY:
	case LMSG_PLAYBACK_DECRYPT_KEY_FAILED:
		GetDlgItem(IDC_EDIT_DECRYPTHINT)->SetWindowText(_T("need decrypt key"));
		break;
	case LMSG_PLAYBACK_DECRYPT_SUCCESS:
		GetDlgItem(IDC_EDIT_DECRYPTHINT)->SetWindowText(_T("decrypt success"));
		break;
	default:
		break;
	}
}


void CFileQueryDlg::OnRemoteDecryptSwallowctrl1( unsigned long _lObsId, unsigned long _lNotifyType )
{
	switch (_lNotifyType)
	{
	case WCM_NEED_DECRYPT_KEY_PLAYBACK:
	case WCM_DECRYPT_KEY_FAILED_PLAYBACK:
		GetDlgItem(IDC_EDIT_DECRYPTHINT)->SetWindowText(_T("need decrypt key"));
		break;
	case WCM_DECRYPT_SUCCESS_PLAYBACK:
		GetDlgItem(IDC_EDIT_DECRYPTHINT)->SetWindowText(_T("decrypt success"));
		break;
	default:
		break;
	}
}


BOOL CFileQueryDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_LBUTTONDBLCLK)
	{ 
		CEdit* pEdit = (CEdit*)GetDlgItem(IDC_EDIT_DECRYPTHINT);
		if(pMsg->hwnd == pEdit->GetSafeHwnd()) 
		{
			pEdit->SetWindowText(_T(""));
		}
	} 
	return CDialog::PreTranslateMessage(pMsg);
}

//ػطŶλ
void CFileQueryDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{

	CSliderCtrl* sldCtrl = (CSliderCtrl*)pScrollBar;

	if (!m_bPlaying && !m_blTempLocalPlayAdjust)
	{
		((CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS))->SetPos(0);
		((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->SetPos(0);
		return;
	}

	if (m_bPlaying || m_blTempLocalPlayAdjust)
	{
		m_bPlaying = FALSE;
		m_blTempLocalPlayAdjust = TRUE;

		if (SB_ENDSCROLL != nSBCode)
		{
			return;
		}

		switch(sldCtrl->GetDlgCtrlID())
		{
		//϶εãʱע͵ͨťʵֶλ
		/*
		case IDC_SLIDER_PROGRESS:
			
			{
				int iPos = 0;
				iPos = ((CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS))->GetPos();

				int iRet = Swallow_Seek(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), iPos);
				if (iRet < 0)
				{
					OutputDebugString("[CFileQueryDlg::OnHScroll] Seek Failed!");
				}
			}
			m_bPlaying = TRUE;
			m_blTempLocalPlayAdjust = FALSE;
			break;*/
		case IDC_SLD_PBK_VOLUME:
			{
				int iPos = 0;
				iPos = ((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->GetPos();

				USHORT usiValume = (double)iPos / 100 * MAX_VALUME_NUM;
				int iRet = Swallow_VolumeSet(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), usiValume);
				if (iRet < 0)
				{
					OutputDebugString("[CFileQueryDlg::OnHScroll] VolumeSet Failed!");
				}

				iRet = Swallow_VolumeGet(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());

				if (iRet < 0)
				{
					OutputDebugString("[CFileQueryDlg::OnHScroll] VolumeGet Failed!");
					break;
				}

				iPos = (double)iRet / MAX_VALUME_NUM * 100;
				((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->SetPos(iPos);

				BOOL blAudio = iPos > 0 ? TRUE : FALSE;
				((CButton*)GetDlgItem(IDC_CHK_VOLUEM_START))->SetCheck(blAudio);

			}
			break;
		default:
			break;
		}
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

//
void CFileQueryDlg::OnBnClickedBtnLocalplaySlowvideo()
{
	if (!m_bPlaying)
	{
		return;
	}
	m_iLocalPlayFastValue = 0;
	m_iLocalPlayStatus = -1;
	m_iLocalPlaySlowValue++;
	if (m_iLocalPlaySlowValue > 4)
	{
		m_iLocalPlaySlowValue = 0;
		OnBnClickedBtnLocalplayPlayPause();
		return;
	}
 
	int iRet = Swallow_Slow(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), m_iLocalPlaySlowValue);
	if (0 > iRet)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplaySlowvideo] Slow Failed!");
	}

	CString csPlayStatus;
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, "Play");
	csPlayStatus.Format("Slow %d", m_iLocalPlaySlowValue);
	SetDlgItemText(IDC_STC_LOCALPLAY_PLAYSTATUS, csPlayStatus);

}

//
void CFileQueryDlg::OnBnClickedBtnLocalplayFastvideo()
{
	if (!m_bPlaying)
	{
		return;
	}
	m_iLocalPlaySlowValue = 0;
	m_iLocalPlayStatus = -1;

	m_iLocalPlayFastValue++;
	if (m_iLocalPlayFastValue > 4)
	{
		m_iLocalPlayFastValue = 0;
		OnBnClickedBtnLocalplayPlayPause();
		return;
	}

	int iRet = Swallow_Fast(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), m_iLocalPlayFastValue);

	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayFastvideo Obs_FastForward_Cmd] Failed!");
	}

	CString csPlayStatus;
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, "Play");
	csPlayStatus.Format("Fast %d", m_iLocalPlayFastValue);
	SetDlgItemText(IDC_STC_LOCALPLAY_PLAYSTATUS, csPlayStatus);

}

//ͣ
void CFileQueryDlg::OnBnClickedBtnLocalplayPlayPause()
{
	if (!m_bPlaying)
	{
		return;
	}
	SetDlgItemText(IDC_STC_LOCALPLAY_PLAYSTATUS, "");

	CString csBtnStatus = (0 == m_iLocalPlayStatus)?"Play":"Pause";
	m_iLocalPlayStatus = ((0 == m_iLocalPlayStatus)?1:0);
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, csBtnStatus);
	int iRet = Swallow_PlayPause(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), m_iLocalPlayStatus);
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayPlayPause] playlause failed");
	}
}

void CFileQueryDlg::OnBnClickedBtnLocalplayStepvideo()
{
	m_iLocalPlayStatus = -1;
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, "Play");
	VARIANT var1 = getitovar(m_pSwallowPlayback->GetCurObs());
	VARIANT var = getitovar(0);
	int iRet = Swallow_Step(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayStepvideo] Step Failed!");
	}
}

//ֹͣ
void CFileQueryDlg::OnBnClickedBtnStopLocalplay()
{
	int iRet = Swallow_Stop(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnStopLocalplay] Stop play Failed!");
		return;
	}
	StopPlayInitVulue();
}

void CFileQueryDlg::StopPlayInitVulue()
{
	m_bPlaying = false;
	((CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS))->SetPos(0);
	m_blTempLocalPlayAdjust = false;
	m_iLocalPlayFastValue = 0;
	m_iLocalPlaySlowValue = 0;	
	m_iLocalPlayStepForward = FALSE;
	m_blBegainClip = FALSE;
	m_iLocalPlayStatus = -1;
	m_cstrPlayRemoteBegainTime.Empty();
	m_cstrPlayRemoteEndTime.Empty();
	SetDlgItemText(IDC_STC_LOCALPLAY_PLAYSTATUS, "");
	SetDlgItemText(IDC_BTN_LOCALPLAY_PLAY_PAUSE, "Play");
	SetDlgItemText(IDC_STC_LOCALPLAY_TIME_NUM, "00:00:00/00:00:00");
	((CButton*)GetDlgItem(IDC_CHK_VOLUEM_START))->SetCheck(FALSE);
	((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->SetPos(0);
}

//ץ
void CFileQueryDlg::OnBnClickedBtnLocalplayCapturePic()
{
	CString csFileName;
	SYSTEMTIME tTime = {0} ;
	GetSystemTime(&tTime);
	csFileName.Format("PIC%04d%02d%02d%02d%02d%02d.bmp", tTime.wYear, tTime.wMonth, tTime.wDay, tTime.wHour+8,
		tTime.wMinute, tTime.wSecond);
	int iRet = Swallow_CapturePic(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), csFileName);
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayCapturePic]   Capture pic Failed!");
	}

}

//Ƶ	Swallowݲ֧ƵȲ
void CFileQueryDlg::OnBnClickedBtnLocalplayCaptureFile()
{
	if (!m_blBegainClip)
	{
		CString csFileName;
		SYSTEMTIME tTime = {0} ;
		GetSystemTime(&tTime);
		csFileName.Format("VIDEO%04d%02d%02d%02d%02d%02d", tTime.wYear, tTime.wMonth, tTime.wDay, tTime.wHour+8,
			tTime.wMinute, tTime.wSecond);
		csFileName += _T(".sdv");
		int iRet = Swallow_StartRecord(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), csFileName);	
		if (iRet < 0)
		{
			OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayCaptureFile Obs_BeginRec_Cmd] Failed!");
			return;
		}
		m_blBegainClip = TRUE;
	}
	else
	{
		VARIANT var1 = getitovar(m_pSwallowPlayback->GetCurObs());
		VARIANT var = getitovar(0);
		int iRet = Swallow_StopRecord(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());	
		if (iRet < 0)
		{
			OutputDebugString("[CFileQueryDlg::OnBnClickedBtnLocalplayCaptureFile Obs_EndRec_Cmd] Failed!");
			return;
		}
		m_blBegainClip = FALSE;
		MessageBox("Video Clip complete !");
	}
}

void CFileQueryDlg::SecondToHour(int _iSecond, CString* _csDstBuffer)
{
	int iTimeHour = _iSecond / 3600;
	int iTimeMin = _iSecond % 3600 / 60;
	int iTimeSecond = _iSecond % 60;
	
	_csDstBuffer->Format("%02d:%02d:%02d", iTimeHour, iTimeMin, iTimeSecond);
}


void CFileQueryDlg::UpdatePlayingTimeByFile()
{
	if (!m_bPlaying)
	{
		return;
	}
	int iTotalTime = Swallow_GetTotalTime(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	int iCurretTime = Swallow_GetCurretTime(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	
	if (iTotalTime < 0)
	{
		OutputDebugString("[CFileQueryDlg::LocalVideoPlayTime Obs_PlayBackTotalTime_Get] Failed !");
		return;
	}

	if (iCurretTime < 0)
	{
		OutputDebugString("[CFileQueryDlg::LocalVideoPlayTime Obs_PlayBackCurTime_Get] Failed !");
		return;
	}
	CString csTotalTime;
	CString csCurTime;
	SecondToHour(iTotalTime, &csTotalTime);
	SecondToHour(iCurretTime, &csCurTime);
	SetDlgItemText(IDC_STC_LOCALPLAY_TIME_NUM, csCurTime + "/" + csTotalTime);
}

//ǰΰʱطʱˢ½沥ʱ
void CFileQueryDlg::UpdatePlayingTimeByTime()
{
	if (!m_bPlaying)
	{
		return;
	}
	int iCurretTime = Swallow_GetCurretTime(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs());
	if (iCurretTime < 0)
	{
		OutputDebugString("[CFileQueryDlg::RemoteByTimePlayTime] PlayBackCurTime_Get Failed !");
		return;
	}

	CString cstrCurrentTime;

	NVS_FILE_TIME stCurrentTime = {0};
	AbsSecondsToNvsFileTime( &stCurrentTime, iCurretTime);

	cstrCurrentTime.Format("%04d-%02d-%02d-%02d-%02d-%02d", stCurrentTime.iYear, 
		stCurrentTime.iMonth, stCurrentTime.iDay, stCurrentTime.iHour, stCurrentTime.iMinute, stCurrentTime.iSecond);

	SetDlgItemText(IDC_STC_LOCALPLAY_TIME_NUM, m_cstrPlayRemoteBegainTime + "/" + cstrCurrentTime + "/" + m_cstrPlayRemoteEndTime);
}

//Ƶ
void CFileQueryDlg::OnBnClickedChkVoluemStart()
{
	if (!m_bPlaying && !m_blTempLocalPlayAdjust)
	{
		((CButton*)GetDlgItem(IDC_CHK_VOLUEM_START))->SetCheck(FALSE);
		return;
	}

	long lobsID  = m_pSwallowPlayback->GetCurObs();
	VARIANT var  = getitovar(0);
	VARIANT var1 = getitovar(lobsID);
	VARIANT var3 = getitovar(50000);
	CStringArray szResult;
	szResult.SetSize(256);

	BOOL blAudioStart = ((CButton*)GetDlgItem(IDC_CHK_VOLUEM_START))->GetCheck();
	if (blAudioStart)
	{		
		VARIANT var2 = getitovar(1);
		CString szRet = m_pSwallowPlayback->Commander(Obs_SpeakerEnable_Set, var1, var2, var3, var, var, var, var, var, var);   
		if (CheckRetValue(szRet, szResult) != 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview]Audio Start Failed!"));
		}

	}
	else
	{
		VARIANT var2 = getitovar(0);
		CString szRet = m_pSwallowPlayback->Commander(Obs_SpeakerEnable_Set, var1, var2, var3, var, var, var, var, var, var);   
		if (CheckRetValue(szRet, szResult) != 0)
		{
			OutputDebugString(_T("[COCXPlayDemoDlg::OnBnClickedChkAudioPreview]Audio Stop Failed!"));
		}
		((CSliderCtrl *)GetDlgItem(IDC_SLD_PBK_VOLUME))->SetPos(0);
	}

}

void CFileQueryDlg::OnBnClickedBtnPbkByTime()
{
	CTime pStartDay;
	DataTime_Start.GetTime(pStartDay);
	int iYear = pStartDay.GetYear();
	int iMonth = pStartDay.GetMonth();
	int iDay = pStartDay.GetDay();

	CTime pStartTime;
	DataTime_StartTime.GetTime(pStartTime);
	int iHour = pStartTime.GetHour();
	int iMinute = pStartTime.GetMinute();
	int iSecond = pStartTime.GetSecond();
	CString szStartTime;
	szStartTime.Format("%04d%02d%02d%02d%02d%02d", iYear, iMonth, iDay, iHour, iMinute, iSecond);
	m_cstrPlayRemoteBegainTime.Format("%04d-%02d-%02d-%02d-%02d-%02d", iYear, iMonth, iDay, iHour, iMinute, iSecond);
	
	CTime pEndDay;
	DataTime_End.GetTime(pEndDay);
	int iStopYear = pEndDay.GetYear();
	int iStopMonth = pEndDay.GetMonth();
	int iStopDay = pEndDay.GetDay();

	CTime pEndTime;
	DataTime_EndTime.GetTime(pEndTime);
	int iStopHour = pEndTime.GetHour();
	int iStopMinute = pEndTime.GetMinute();
	int iStopSecond = pEndTime.GetSecond();
	CString szStopTime;
	szStopTime.Format("%04d%02d%02d%02d%02d%02d", iStopYear, iStopMonth, iStopDay, iStopHour, iStopMinute, iStopSecond);
	m_cstrPlayRemoteEndTime.Format("%04d-%02d-%02d-%02d-%02d-%02d", iYear, iMonth, iDay, iHour, iMinute, iSecond);
	
	int iChannelNo = m_CboChannelNo.GetCurSel() - 1;
	if (iChannelNo < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnPbkByTime] Err Choose All Channel");
		return;
	}
	int iStreamNo = m_CboStream.GetItemData(m_CboStream.GetCurSel());

	int iRet = Swallow_PlayRemoteByTime(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), m_iLogonID, 
											PLAYBACK_TYPE_REMOTE, iChannelNo, iStreamNo, szStartTime, szStopTime);
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnBnClickedBtnPbkByTime] PlayRemoteByTime Failed !");
		m_cstrPlayRemoteBegainTime.Empty();
		m_cstrPlayRemoteEndTime.Empty();
		return;
	}

	m_bPlaying = true;
	SetTimer(1, 500, NULL);

}

void CFileQueryDlg::InitStreamCbo()
{
 	m_CboStream.ResetContent();
 	m_CboStream.SetItemData(m_CboStream.AddString(_T("MainStream")), 0);
	m_CboStream.SetItemData(m_CboStream.AddString(_T("SubStream")), 1);
	m_CboStream.SetItemData(m_CboStream.AddString(_T("ThirdStream")), 2);
	m_CboStream.SetCurSel(0);
}




void CFileQueryDlg::OnBnClickedBtnLocalplaySeek()
{
	// TODO: Add your control notification handler code here

	int iPos = GetDlgItemInt(IDC_EDIT_DOWNLOAD_SEEK);
	if(iPos < MIN_SEEK_NUM || iPos > MAX_SEEK_NUM)
	{
		return;
	}

	int iRet = Swallow_Seek(m_pSwallowPlayback, m_pSwallowPlayback->GetCurObs(), iPos);
	if (iRet < 0)
	{
		OutputDebugString("[CFileQueryDlg::OnHScroll] Seek Failed!");
		return;
	}
	((CSliderCtrl *)GetDlgItem(IDC_SLIDER_PROGRESS))->SetPos(iPos);
}
